/*---------------------------- credit.cc -----------------------------
  Most credit card companies compute interest on an average daily
  balance. This program computes the average daily balance and
  monthly interest charge on a credit card,
    given: 	the net balance shown on a customer's statement
   			the number of days in billing cycle
         	the net payment received and date of receipt
            and monthly interest rate
  Here's the algorithm for computing the average daily balance and
   		monthly interest charge:
    (1) net balance * number of days in billing cycle
    (2) net payment * number of days received before statement date
    (3) balance after payment = result of (2) - result of (1)
    (4) average daily balance = (3) / number of days in billing cycle
    (5) monthly interest charge = average daily balance
         		* monthly interest rate
  Programmer: Glenn D. Blank  
  For chapter 3 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
  Debugged by:
Your mission: find the errors in this program and fix them!
  Use function key F4 to find the errors in this program;
     F6 to goto the line where the error occurs;
     F7 to get help about the error messages you don't understand;
  Edit the program and keep recompling (F4 or F5) until it works!
  Then make sure there are no LOGICAL errors:
  	does the program do what it's supposed to do?
  	Is the output of the program what was intended?
---------------------------------------------------------------------*/
#include <iostream.h>

void main()
{ float balance;	//net balance shown on customer's statement, from user
  int cycleDays;	//number of days in billing cycle, from user
  float payment;  //net payment received from customer, from user
  int receiptDays;//day received, before next billing statement, from user
  float rate;	   //monthly interest rate, from user

  //prompt user and read each input item
  cout << "Input net balance on statement:";
  cin >> balance;
  cout << "Input number of days in billing cycle:";
  cin >> cycleDays;
  cout << "Input net payment:
  cin >> payment;
  cout << "How many days before this statement was payment received:";
  cin >> receiptDays;

  //Calculate average daily balance
  float newBalance = balance*cycleDays - payment*receiptDays; //steps (1)-(3)
  float avgDailyBalance = newBalance / cycleDays;	  //step (4)
  float monthlyCharge = avgDailyBalance * rate;		  //step (5)

  //Output results
  cout << "avgDailyBalance=" avgDailyBalance << endl;
  cout << "monthlyCharge=" monthlyCharge << endl;
}

