/*------------------------- randtest.cc ------------------------------
  Tests class Randomizer, which generates pseudo-random numbers
  Programmer: Jesse Thilo
  For chapter 5 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
--------------------------------------------------------------------*/
#include <iostream.h>
#include "\umach\cpp\libfiles\random.h"

void main()
{
  //Random number class generates pseudo-random numbers (e.g., for games)
  cout << "\nDemonstrating Randomizer class...." << endl;
  Randomizer rand;
  int i;
  long seed;

  cout << "Enter an integer to seed the random number generator.\n"
       << "Enter 0 to let the computer pick the seed: ";
  cin >> seed;

  rand.reseed(seed);
  cout << endl;

  cout << "Some random numbers from 1 to 10: " << endl;
  i=0;
  while (i < 10)
  { cout << rand.randomUpTo(10) + 1 << " ";
    i++;
  }
  cout << endl << endl;

  cout << "Some random numbers from 0 to " << MAXRANDOM  << ": " << endl;
  i=0;
  while (i < 10)
  { cout << rand.random() + 1 << " ";
    i++;
  }

  cout << "Some random real numbers from 0 to 0.999999...: " << endl;
  i=0;
  while (i < 10)
  { cout << rand.random0to1() + 1 << " ";
    i++;
  }
  cout << endl;
}

