/*--------------------------- shaptest.cpp ----------------------------
  Test and demonstrate shape classes of Lookout library.
  Shape classes represents and draws geometric shapeson a DOS screen.
  The implementation details of making a computer draw shapes in DOS
  have been "hidden" in a library; you only to learn the interface,
  in shapes.h, or learn by analogy from this program.
  Note: to display graphics on a DOS screen, the implementation
  needs to switch out of text mode.  The library code takes care of
  the details of switching between text and graphics mode,
  but you need to have the following line in your program after
  you are done with graphics processing:
  	cin.get();	//reactivate text mode
  Note for compiling with Borland C++ 5.0:
  	Create a new project called shaptest.
	Use Target Expert to set project with these settings:
	DOS STANDARD platform, LARGE target model, BGI on.
	Add LOOKOUT.LIB to your project (using the Insert key).
  The multimedia explains this procedure in detail:
	in "UM", click on the Find button and look for "
  Programmer: Glenn D. Blank
  For chapter 5 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
--------------------------------------------------------------------*/
//include LOOKOUT's shapes header file
#include "\umach\cpp\libfiles\shapes.h"
#include <iostream.h>
#include <conio.h>

void main()
{
  //Some useful facts (invariants) about a VGA screen
  const int centerX=320;	//middle of screen, 640 pixels wide
  const int centerY=240;	//middle of screen, 320 pixels high

   //Construct some shapes
  Circle c(1.5);		//defaults to upper left corner
  Triangle t(2.0);
  Rectangle r(2.0, 3.0, centerX,centerY); //put this in the middle
  Line line(70,30,170,230);

  cout << "Switching from text to graphics mode.  Press Enter to return to quit.";
  //The above line isn't necessary; it's informational
  
  //Move and draw the shapes
  c.move(270, 200);
  c.draw();

  t.move(370,280);
  t.draw();

  r.draw();

  line.draw();
  getch();     //read any character

}

