/*---------------------------- strtest.cpp ----------------------------
Test and demonstrate capabilities of class String of Lookout library.
   Uses Lstring.h and lookout library
   Note for compiling with Borland C++ 5.0:
	Use Target Expert to set project with these settings:
	DOS STANDARD platform, LARGE target model, Class Library off.
	Then insert lookout.lib in your project.
  Programmer: Glenn D. Blank
  For chapter 5 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
--------------------------------------------------------------------*/
#include <iostream.h>
#include "\umach\cpp\libfiles\Lstring.h"
//#include header file for Lookout's Lstring class

void main()
{
  //First, construct a few Lstrings
  Lstring s1;	    //default constructor is empty CSTRING, ""
  Lstring s2="xyz"; //providing initial value, "xyz"
  Lstring s3=s2;    //copy constructor copies from another Lstring

  //display two Lstrings with initial values
  cout << "empty s1=" << s1 << endl;
  cout << "s2 initialzed to:" << s2 << endl;
  cout << "s3 copied from s1:=" << s3 << endl;

  //length() and size() compute length of Lstring
  cout << "s1=" << s1 << " s1.length()=" << s1.length() << endl;
  cout << "s2=" << s2 << " s2.length()=" << s2.length() << endl;
  cout << "s3=" << s3 << " s3.size()=" << s3.size() << endl;

  //assignment copies a value into an Lstring
  s1 = s2;
  cout << "s1's value after assignment, s1=s2:" << s1 << endl;

  //read a whole line (up to a newline rather than a space)
  cout << "Enter a few words, then press Enter:";
  s3.readLn();
  cout << "s3=" << s3 << endl;

  //concatenation assembles an Lstring out of two other Lstrings
  s1 = s2 + s3;
  cout << s2 << "+" << s3 << "(concatenation):" << s1 << endl;
  cout << s2 + "+" << s3 << endl;  //can concatenate CSTRINGS, too

  /* Note: the find() and substr() functions deal with individual
     characters in an Lstring.  The first character is a string
     is at the 0th position (rather than 1st).  So in the string
     "George", the character 'G' is at position 0, 'e' at 1, etc. */
  //find() searches for a start of an Lstring within an Lstring
  // find() returns a character index, where first character is 0
  s1 = "George Washington";
  int G = s1.find("G");	      //find 'G' in s1
  cout << "G is at character " << G << " in " << s1 << endl;
  int space = s1.find(" ");   //find space in s1
  cout << "Space is at character " << space << " in " << s1 << endl;
  //find() takes a second argument specifying where to start search
  int g = s1.find("g",space+1); //find 'g' past space, using 2nd arg
  cout << "'g' is at character " << g << " in " << s1 << endl;
  //find() returns -1 to indicate failure
  int m = s1.find("Martha"); 	//attempt to find "Martha" in s1
  cout << m << " is result of s1.find(\"Martha\");" << endl;

  //substr() returns a subString of an Lstring
  s2 = s1.substr(0,space-1);  	//returns first namekin
  s3 = s1.substr(space+1,s1.length()); //returns last name
  cout << "First name=" << s2 << " Last name=" << s3 << endl;

  //added numeric conversion functions to Lstring, 11/98
  int i; float f;
  s3.fromInteger(7);
  cout << "Testing numeric conversion functions..." << endl;
  cout << "fromInteger is " << s3 << endl;
  i = s3.toInteger();
  cout << "toInteger is " << i << endl;
  s3.fromFloat(3.14);
  cout << "fromFloat is " << s3 << endl;
  f = s3.toFloat();
  cout << "toFloat is " << f << endl;
}

