/*---------------------- loopbugs.cc: Buggy loops --------------------
  Loops are a common source of logical errors.
  Let's see if you can debug them!
  When you think you have gotten all of the bugs out,
    try executing the program with salaries that are all distinct 
    and in increasing order (e.g., 100, 101, 102).
  NOTE: in LOOKOUT, you can only compile this file with F5, not F4.
  For chapter 7 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
--------------------------------------------------------------------*/
#include <iostream.h>
#include <limits.h>
//limits.h includes declarations of system-dependent constants,
//including INT_MAX, the maximum value of an int on this platform

void main()
{
  //Where's the bug in the following code fragment?
  //If you're not sure, use a debugger to help you figure it out.
  int counter = 1;
  while (counter < 100)
  { cout << counter << endl;
    counter = counter - 1;
  }
  //What do you learn about writing correct loops from this example?

  //Where's the bug in the following code fragment?
  //If you're not sure, use a debugger to help you figure it out.
  counter = 1;
  while (counter < 100)
     cout << counter << endl;
     counter = counter + 1;
  //What do you learn about writing correct loops from this example?

  
/*--------------------------------------------------------------------
The following program reads a list of salaries and determines the
   salary range.  (A sentinel salary value of 0 indicates end of input.)
   Input: A list of salaries in thousands of dollars.
   Output: User prompts, labels, and the salary range.
--------------------------------------------------------------------*/
  const int sentinel=0;	 //end of data indicator
  int salary;		 //current salary being processed
  int maxSalary=0;	 //largest salary read so far
  int minSalary=INT_MAX; //smallest salary read so far

  cout << "Enter salaries in thousands of dollars (0 to stop).\n";

  //Loop to read in salary values
  while (salary != sentinel)  //Loop until getting sentinel from user
  { cout << "Enter salary:";
    cin >> salary;
    if (salary > maxSalary)
	maxSalary = salary;
    else if (salary < minSalary)
	minSalary = salary;
  }

  cout << "\nSalary range = " << maxSalary - minSalary
	<< " thousand dollars." << endl; 
}
