/*-------------- payroll.cc: An hourly payroll program ---------------
Compute a weekly pay, given the number of hours worked and hourly rate 
     Factor in overtime rate (1.5) for first 10 hours in excess of 40, 
     then double-time rate (2.0) for any extra hours.
  Programmer: Glenn D. Blank (for "The Megabyte Company")
  For chapter 7 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
---------------------------------------------------------------------*/
#include <iostream.h>

void main()
{
  float workHours; //hours worked in a week, input from user
  float hourlyRate;     //regular pay scale per hour, input from user
  const float overtimeRate=1.5;   //factor to compute overtime pay
  const float doubletimeRate=2.0; //factor to compute double-time pay
  const int overtimeCutoff=40;    //overtime threshold
  const int doubletimeCutoff=50;  //doubletime threshold
  float weeklyPay; //regular pay+overtime pay+doubletime pay

  //Prompt user for work hours and hourly rate
  cout << "------- Megabyte Company payroll program -------" << endl;
  cout << "Enter hours worked this week followed by hourly payrate:";
  cin >> workHours >> hourlyRate;
  
  //Calculate weekly pay, factoring in any overtime or doubletime
  if (workHours <= overtimeCutoff)
     weeklyPay = workHours*hourlyRate;

  if (workHours > overtimeCutoff && workHours <= doubletimeCutoff)
     weeklyPay = overtimeCutoff*hourlyRate + 
              (workHours-overtimeCutoff)*overtimeRate*hourlyRate;

  if (workHours > doubletimeCutoff)
     weeklyPay = overtimeCutoff*hourlyRate + 
              (doubletimeCutoff-overtimeCutoff)*overtimeRate*hourlyRate
              + (workHours-doubletimeCutoff)*doubletimeRate*hourlyRate;

  //Display weekly pay
  cout << "Weekly pay is $" << weeklyPay << endl;
}
