/*-------------------------- change9.cpp -----------------------------
  Improved version of change machine.
  Uses functions to decompose the system.
    and function parameters to generalize the functions.
  Programmer: Glenn D. Blank
  For chapter 11 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
------------------------------------------------------------------*/
#include <iostream.h>
#include "..\libfiles\Lstring.h"

float readMoney(const Lstring & msg)  //prompt, read user value
{ float amount; //user-supplied amount
  cout << "Please enter " << msg << ":";   
  cin >> amount;
  return amount;
}

bool validAmounts(float price,float tendered) //test constraint
{ if (tendered - price < 0)
  { cout << "Sorry, " << tendered << " is not enough to cover "
 	 << price << ".  Please try again." << endl;
	return false;
  }
  else return true;
}	

int numCoins(int change,int unit,int & remainder)
//compute coins of unit amount from change, leaving remainder
{ int coins;
  coins = change / unit;	//how many coins for this change
  remainder = change % unit; //how much left after taking coins?
  return coins;
}

void computeChange(float price,float tendered,int& change,
   int& dollars,int& quarters,int& dimes,int& nickels,int& pennies)
//return change, # of $s, quarters, dimes, nickels & pennies
{ change = int(tendered*100) - int(price*100); //convert to int
  int remainder; //holds remainder computed by unit functions
  dollars = numCoins(change,100,remainder);
  quarters = numCoins(remainder,25,remainder);
  dimes = numCoins(remainder,10,remainder);
  nickels = numCoins(remainder,5,remainder);
  pennies = remainder; //left over from computing nickels
}

void showChange(int change,int dollars,int quarters,int dimes,
		int nickels,int pennies) //show change then by $s, etc.
{ cout << change << " cents in change:" << endl;
  cout << "\t" << dollars << " dollars" << endl;
  cout << "\t" << quarters << " quarters" << endl;
  cout << "\t" << dimes << " dimes" << endl;
  cout << "\t" << nickels << " nickels" << endl;
  cout << "\t" << pennies << " pennies" << endl;
}

void main()
{ float price = readMoney("purchase price");
  float tendered = readMoney("amount tendered");
  int change; //tendered - price in pennies
  int dollars,quarters,dimes,nickels,pennies; //compute these
  if (validAmounts(price,tendered))
  { computeChange(price,tendered,change,dollars,quarters,
				dimes,nickels,pennies);
  }
  showChange(change,dollars,quarters,dimes,nickels,pennies);
}
