/*--------------------------- datetest.cpp ---------------------------
  Driver to test functions implemented in file date.cc.
  Illustrates function prototypes and bottom-up testing techniques.
  To create this program, you must use a multi-file project.
Compiling a multi-file project in LOOKOUT (one that exists already):
  Open file (F2) datetest.prj, then select F4 or F5 to compile.
Creating a multi-file project in LOOKOUT (if it doesn't exist yet):
  Press F9 (or mouse to select menu option Lookout, then Open Project);
  The file manager will prompt for a project name: 
  	Type "mydate.prj" (Note: you must include the .prj extension!)
  The file manager will prompt for files to include in the project:
	Select datetest.cc, then date.cc, then press Esc key or Cancel.
	(Note: you don't have to include any .h files, just .cc files.)
  Press F4 or F5 to compile.  LOOKOUT will compile and link all files.
Creating a multi-file project using other compilers:
  The multimedia gives a step by step description of the Borland IDE;
	in the "UM" program (not "UMCPP"), press the FIND button,
  	enter "datetest" and review this subsection of chapter 4.
  Most C++ compilers provide similar facilities for projects.
  	Remember that lookout.lib (or the library source code in
  	\gcc\lookout\libfiles) must be compiled in DOS STANDARD mode.
  Programmer: Glenn D. Blank  
  For chapter 9 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
--------------------------------------------------------------------*/
#include "..\lib\Lstring.h"

//Declare prototypes for functions defined in date.cpp
int getNumMonth(Lstring month);     //given Lstring, return int form
Lstring getDecadeYear(Lstring year); //given " 1990", return "90"
void getParts(Lstring inDate,Lstring& month,Lstring& day,Lstring& year);
//Given a spelled-out date, break it up into three subLstrings
void getDate(); //Given "month day, year", write "month/day/year"

void main()
{
  cout << "August=>" << getNumMonth("August") << endl;   //test valid case
  cout << "Invalid=>" << getNumMonth("Invalid") << endl; //test invalid case
  cout << " 1990=>" << getDecadeYear(" 1990") << endl;   //test valid case
  cout << "November 22, 1963 parts=> ";
  Lstring m,d,y;  //parameters returned by getParts
  getParts("November 22, 1963",m,d,y);                   //test valid case
  cout << m << ' ' << d << ' ' << y << endl;
  cout << "Please enter a valid date..." << endl;
  getDate();                                             //user tests valid case
  cout << "Please enter an invalid date (e.g.: May 32, 2200) to test assertion..." << endl;
  getDate();                                             //user tests invalid case
}
