/*--------------------------- hanoi.cc -------------------------------
The Towers of Hanoi game:
  Given some number of disks stacked in decreasing size on a peg,
  show, step by step, how to move the disks to another peg.
  Constraints: can move just one disk at a time;
		 cannot put a larger disk on a smaller one.
  There are three pegs--the third one is for temporary storage.
  This program illustrates recursion to solve the problem elegantly!
  Programmer: Glenn D. Blank
  For chapter 9 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
--------------------------------------------------------------------*/
#include <iostream.h>

void TowersOfHanoi(int numDisks,char peg1, char peg2, char peg3)
{ //move numDisk disks, assumed to be on peg1, to peg3, with peg2
  if (numDisks > 0)  //solved this (sub-)problem?
  { // 1) move n-1 disks from peg1 to peg2 (temporary storage peg)
    TowersOfHanoi(numDisks-1,peg1,peg3,peg2);

    // 2) move the last (largest) disk from peg1 to peg3
    cout << "Move disk from peg " << peg1 << " to peg " << peg3 << endl;

    // 3) move n-1 disks from peg2 to peg3 (on top of largest disk)
    TowersOfHanoi(numDisks-1,peg2,peg1,peg3);
  }
}

void main()
{ int numDisks;	//number of disks to move, from user

  //prompt user for numDisks
  cout << "How many disks in this tower? ";
  cin >> numDisks;

  TowersOfHanoi(numDisks,'A','B','C');
  cout << "Done!" << endl;
}

