/*-------------------------- prepost.cc -----------------------------
  Another version of change machine,
	now illustrating preconditions and postconditions.
  NOTE: look for a new version of function computeChange()
   	and study the precondition and postcondition.
   	Then try to cause each of them to fail!
  Programmer: Glenn D. Blank (for "The Megabyte Company")
  For chapter 9 of "The Universal Machine"
  Copyright (C) WCB/McGraw-Hill, 1998
------------------------------------------------------------------*/
#include <iostream.h>
#include "..\libfiles\Lstring.h"

int numCoins(int change,int unit,int & remainder)
//compute coins of unit amount from change, leaving remainder
{ int coins;
  coins = change / unit;	//how many coins for this change
  remainder = change % unit; 	//how much left after taking coins?
  return coins;
}

#include <assert.h>
void computeChange(float price,float tendered,int & change,
       int& dollars,int& quarters,int& dimes,int& nickels,int& pennies)
{ 
  //precondition: amount tendered must cover the price
  assert(tendered >= price);

  /* body of function as before */
  change = int(tendered*100) - int(price*100); //convert to int
  int remainder; //holds remainder computed by unit functions
  dollars = numCoins(change,100,remainder);
  quarters = numCoins(remainder,25,remainder);
  dimes = numCoins(remainder,10,remainder);
  nickels = numCoins(remainder,5,remainder);
  pennies = remainder; //left over from computing nickels

  //postcondition: units disbursed should equal total change
  assert(dollars*100+quarters*25+dimes*10+nickels*5+pennies==change); 
}

float readMoney(const Lstring & msg)  //prompt, read user value
{ float amount; //user-supplied amount
  cout << "Please enter " << msg << ":";   
  cin >> amount;
  return amount;
}

/* Function validAmounts() commented out.  Try to figure out why.
   Once you have, do you think that was a good idea? 
bool validAmounts(float price,float tendered) //test constraint
{ if (tendered - price < 0)
  { cout << "Sorry, " << tendered << " is not enough to cover "
 	 << price << ".  Please try again." << endl;
	return false;
  }
  else return true;
}	
*/

void showChange(int change,int dollars,int quarters,int dimes,
		int nickels,int pennies) //show change then by $s, etc.
{ cout << change << " cents in change:" << endl;
  cout << "\t" << dollars << " dollars" << endl;
  cout << "\t" << quarters << " quarters" << endl;
  cout << "\t" << dimes << " dimes" << endl;
  cout << "\t" << nickels << " nickels" << endl;
  cout << "\t" << pennies << " pennies" << endl;
}

void main()
{ float price = readMoney("purchase price");
  float tendered = readMoney("amount tendered");
  int change; //tendered - price in pennies
  int dollars,quarters,dimes,nickels,pennies; //compute these
/*  if (validAmounts(price,tendered)) */
     computeChange(price,tendered,change,dollars,quarters,
				dimes,nickels,pennies);
  showChange(change,dollars,quarters,dimes,nickels,pennies);
}
